#!/bin/bash

# kill (recursively) the whole process tree started by the
# process with given PID. Also kills the process itself.

KILLTREE=$0

function kill_tree(){

	local PID_L="$1"
	for CHILD in `ps -o ppid,pid -A | grep ^[[:space:]]*$PID_L[[:space:]]`
	do
#		echo killing `ps -o pid,cmd -A | grep ^[[:space:]]*$CHILD[[:space:]]`
		if [ ${CHILD} -ne ${PID_L} ]
		then
#			echo "father $PID_L, killing child  $CHILD"
			kill_tree $CHILD
		fi

	done

#	echo "ps -A | grep ^[[:space:]]*$PID_L[[:space:]] | awk '{print($1)}"
#	echo `ps -A | grep ^[[:space:]]*$PID_L[[:space:]] | awk '{print($1)}'`
	if [ `ps -A | grep ^[[:space:]]*$PID_L[[:space:]] | awk '{print($1)}'` ]
	then
#		echo "kill -9 $PID_L"
		kill -9 $PID_L
	fi

	return
}

if [ $# -ne 1 ]
then 
	echo Usage: `basename $0` {PID}
else
	PID="$1"

	for CHILD in `ps -o ppid,pid -A | grep ^[[:space:]]*${PID}[[:space:]]`
	do
#		echo killing `ps -o pid,cmd -A | grep ^[[:space:]]*$CHILD[[:space:]]`
		if [ ${CHILD} -ne ${PID} ]
		then
#			echo "father $PID, killing child  $CHILD"
#			exec $KILLTREE $CHILD
			kill_tree $CHILD
		fi

	done


#	echo "ps -A | grep ^[[:space:]]*$PID[[:space:]] | awk '{print($1)}"
#	echo `ps -A | grep ^[[:space:]]*$PID[[:space:]] | awk '{print($1)}'`
	if [ `ps -A | grep ^[[:space:]]*$PID[[:space:]] | awk '{print($1)}'` ]
	then
#		echo "kill -9 ${PID}"
		kill -9 ${PID}
	fi

fi